---
tomcat_version: 10.1.13
tomcat_proxy: "{{ gs_proxy }}"
tomcat_temp_dir: "{{ gs_download_temp_dir }}"
tomcat_ssl_connector_port: 8443  # TODO komt niet voor in Windows role, alleen in Linux
tomcat_versions:
  9.0.78:
    url: https://archive.apache.org/dist/tomcat/tomcat-9/v9.0.78/bin/apache-tomcat-9.0.78.exe
    checksum: bc22886bebef26205abbdb99284405f34cb9725c2bec803d0d98f239beface4eac37d3d4841dc118ad62301d50707fb7c6966b4abc3f875a96a2c86acf1095a3
    checksum_algorithm: sha512
    # supported java versions: 8 and later
  10.1.13:
    url: https://dlcdn.apache.org/tomcat/tomcat-10/v10.1.33/bin/apache-tomcat-10.1.33.exe
    checksum: d4223b1975a5c7e5ec9f7f1cbe1e70913df541a8417011d400d753ad86b9900d
    checksum_algorithm: sha256
tomcat_clean_install_artifacts: false
tomcat_service:
  enabled: true
tomcat_java_home: "{{ java_versions[java_version]['home'] }}"
gs_fme_flow_keystore_filename: "{{ gs_certificate_alias }}-{{ ansible_hostname }}.keystore"

tomcat_service_check:
  enabled: true
  url: "https://gsd-tomcat2.apps.c2platform.org:8443/"
  return_content: true
  validate_certs: false
  content: Apache Tomcat

# tomcat_acl:
#   home:
#     - path: "{{ tomcat_home }}"
#       entity: vagrant
#       etype: group
#       permission: r-x
#       state: present
#       default: yes

tomcat_win_resources:
  tomcat:
    - name: Deploy helloworld
      type: win_get_url
      url: https://tomcat.apache.org/tomcat-7.0-doc/appdev/sample/sample.war
      dest: "{{ tomcat_home }}/webapps/helloworld.war"
      notify: Restart Tomcat service
    - name: Deploy Jolokia JSON JMX Agent
      type: win_get_url
      url: https://repo1.maven.org/maven2/org/jolokia/jolokia-agent-war-unsecured/2.1.1/jolokia-agent-war-unsecured-2.1.1.war
      dest: "{{ tomcat_home }}/webapps/jolokia.war"
      notify: Restart Tomcat service
    - name: Configure HTTPS
      type: win_copy
      dest: "{{ tomcat_home }}/conf/server.xml"
      content: "{{ gs_tomcat_server_xml }}"
      backup: true
      notify: Restart Tomcat service
    - name: Configure context.xml, web.xml
      module: win_xml
      resources:
        - path: "{{ tomcat_home }}/conf/context.xml"
          xpath: /Context
          fragment: >-
            <Valve className="org.apache.catalina.authenticator.SSLAuthenticator"
            disableProxyCaching="false" />
          notify: Restart Tomcat service
        - path: "{{ tomcat_home }}/conf/web.xml"
          backup: true
          xpath: /*[local-name()='web-app']
          fragment: >-
            <security-constraint>
              <web-resource-collection>
                <web-resource-name>HTTPSOnly</web-resource-name>
                <url-pattern>/*</url-pattern>
              </web-resource-collection>
              <user-data-constraint>
                <transport-guarantee>CONFIDENTIAL</transport-guarantee>
              </user-data-constraint>
            </security-constraint>
          notify: Restart Tomcat service
    # - name: Test
    #   type: template
    #   src:
    #   dest:
    - name: Chocolatey
      type: win_chocolatey
      resources:
        - name: notepadplusplus
          version: 8.5.7
        - name: keystore-explorer.portable
          version: 5.5.2
    - name: Shortcuts
      type: win_shortcut
      resources:
        - name: Shortcut → GitBash.exe
          dest: '%Public%\Desktop\Git Bash.lnk'
          # arguments: --cd-to-home
          src: 'C:\Program Files\Git\git-bash.exe'
        - name: Shortcut → Java security
          dest: '%Public%\Desktop\Java lib security.lnk'
          src: 'D:\Apps\jdk-17.0.5\jdk-17.0.5+8\lib\security'
          # directory: 'D:\Apps\jdk-17.0.5\jdk-17.0.5+8\lib\security'
        - name: Shortcut → Java conf security
          dest: '%Public%\Desktop\Java conf security.lnk'
          src: 'D:\Apps\jdk-17.0.5\jdk-17.0.5+8\conf\security'
          # directory: 'D:\Apps\jdk-17.0.5\jdk-17.0.5+8\conf\security'
        - name: Shortcut → scripts
          dest: '%Public%\Desktop\Scripts.lnk'
          src: 'cmd.exe'
          directory: 'c:\vagrant\scripts\gsd-tomcat'
        - name: Shortcut → KeyStore Explorer
          dest: '%Public%\Desktop\KeyStore Explorer.lnk'
          src: 'C:\ProgramData\chocolatey\lib\keystore-explorer.portable\tools\kse-552\kse.exe'
    - name: Git Bash environment
      type: win_copy
      resources:
        - name:
          content: |
            alias rws-tail="tail -f /D/Apps/tomcat/logs/*.log"
            alias rws-tail-tomcat="tail -f /D/Apps/tomcat/logs/*.log"
          dest: C:\Program Files\Git\etc\profile.d\aliases.sh
    - name: Open port 8443 for Tomcat
      type: win_firewall_rule
      localport: 8443
      action: allow
      direction: in
      protocol: tcp
      profiles:
        - private
        - public
        - domain
      state: present
      enabled: true
